//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main_Form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	for (int i=0;i<NTHREAD;i++)
	{
		unsigned int n=crashThreads[i]->GetRunCount();
		double t=crashThreads[i]->GetRunSeconds();
		if (t>maxTime[i]) maxTime[i]=t;
    StringGrid1->Cells[0][i+1]=IntToStr(i);
    StringGrid1->Cells[1][i+1]=IntToStr(n);
    StringGrid1->Cells[2][i+1]=FloatToStrF(t,ffFixed,8,4);
    StringGrid1->Cells[3][i+1]=FloatToStrF(maxTime[i],ffFixed,8,4);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{

	timeBeginPeriod(C_PERIOD);

	for (int i=0;i<NTHREAD;i++)
	{
		maxTime[i]=0.0;
		crashThreads[i]=new TCrashThread();
		if (i>0)
		{
			crashThreads[i]->pullThread=crashThreads[i-1];
		}
	}

	for (int i=0;i<NTHREAD;i++)
	{
		switch (i)
		{
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
			crashThreads[i]->StartThread(tpTimeCritical);
			break;
		case 5:
		case 6:
		case 7:
			crashThreads[i]->StartThread(tpHighest);
			break;
		case 8:
		case 9:
			crashThreads[i]->StartThread(tpHigher);
			break;
		case 10:
			crashThreads[i]->StartThread(tpNormal);
			break;
		}
	}

  Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  Timer1->Enabled=false;

	for (int i=0;i<NTHREAD;i++)
	{
		crashThreads[i]->StopThread();
	}

	for (int i=0;i<NTHREAD;i++)
	{
		delete crashThreads[i];
	}

	timeEndPeriod(C_PERIOD);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TCrashThread::TCrashThread(void):TThread(true),
RunCount(0),RunSeconds(0.0),pullThread(NULL)
{
	FreeOnTerminate=false;
}
//---------------------------------------------------------------------------
void TCrashThread::StartThread(TThreadPriority priority)
{
	// reset control variables
	RunCount=0;
	RunSeconds=0.0;

  Priority=priority;

	// start the thread
  Resume();
}
//---------------------------------------------------------------------------
void TCrashThread::StopThread(void)
{
  Terminate();
  WaitFor();
}
//---------------------------------------------------------------------------
void TCrashThread::StartRunEvent(void)
{
	// reset control variables
  RunCount++;
	HRT.HighResReset();
}
//---------------------------------------------------------------------------
void TCrashThread::StopRunEvent(void)
{
	// use high res timer
	RunSeconds=HRT.HighResTime();
}
//---------------------------------------------------------------------------
void __fastcall TCrashThread::Execute(void)
{
	const int DT=C_PERIOD;
	HANDLE hTE=(HANDLE)CreateWaitableTimer(NULL,false,NULL);

	if (hTE!=NULL)
	{
		LARGE_INTEGER tLT;
		tLT.QuadPart=0;
		if (!SetWaitableTimer(hTE,&tLT,DT,NULL,NULL,true))
		{
			CloseHandle(hTE);
			hTE=NULL;
		}
	}

	while (!Terminated)
	{
		try
		{
			StartRunEvent();

			// loop count of 1 may not fail for a long time
      // increase from 10 to 20 for quick failures
			for (int p=0;p<5;p++)
			{
        s1=IntToStr(rand());

				if (pullThread!=NULL)
				{
					s2=pullThread->s1;
				}
			}

			StopRunEvent();
		}
		catch (...)
		{
		}

		if (hTE==NULL) Sleep(DT);
		else WaitForSingleObject(hTE,DT*4);
	}

	if (hTE!=NULL) CloseHandle(hTE);
}
//---------------------------------------------------------------------------

